////////////////////////////////////////////////////////////////////////////
//           ps for Windows   Ver. 0.5
//                                   Copyright(C) 2006 ksk@binzume.net

// USAGE:  ps


#include <windows.h>
#include <tlhelp32.h>
#include <stdio.h>

int main(int argc,char **argv)
{
	bool flag_l = false;
	int i;

	for (i=1;i<argc;i++) {
		if (argv[i][0]=='-') {
			char *c=argv[i]+1;
			while (*c) switch(*c++) {
			case 'l':
				flag_l = true;
				break;
			case 'a':
			case 'x':
				break;
			case 'h':
				printf("USAGE: %s [-l]\n",argv[0]);
				return 0;
			default:
				printf("USAGE: %s [-l]\n",argv[0]);
				return 1;
			}
		}
	}

	HANDLE hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if ( INVALID_HANDLE_VALUE == hProcessSnap ) {
		fprintf(stderr,"Create toolhelp32 snapshot failed with %u.\n", GetLastError() );
		return 1;
	}
	
	PROCESSENTRY32 pe32;
	ZeroMemory( &pe32, sizeof (pe32) );
	pe32.dwSize = sizeof(PROCESSENTRY32);
	if (flag_l) {
		printf("  PID  PPID  PRI THR     TIME COMMAND\n");
	} else {
		printf("  PID     TIME COMMAND\n");
	}
	if (Process32First(hProcessSnap, &pe32 )) {
		char tim[16] = " X:XX.XX";
		do {
			HANDLE hProc = OpenProcess(PROCESS_QUERY_INFORMATION, TRUE, pe32.th32ProcessID);
			if (hProc) {
				FILETIME utime,ktime,dummy;
				SYSTEMTIME time;
				GetProcessTimes(hProc,&dummy,&dummy,&ktime,&utime);
				utime.dwLowDateTime += ktime.dwLowDateTime;
				utime.dwHighDateTime += ktime.dwHighDateTime;
				if (utime.dwLowDateTime < ktime.dwLowDateTime) utime.dwHighDateTime++;
				FileTimeToSystemTime(&utime,&time);
				CloseHandle(hProc);
				sprintf(tim,"%2d:%02d.%02d", time.wHour, time.wMinute, time.wSecond);
			}
			if (flag_l) {
				printf("%5d %5d   %2d %3d %s %s\n", pe32.th32ProcessID,
					pe32.th32ParentProcessID,pe32.pcPriClassBase, pe32.cntThreads, tim, pe32.szExeFile); 
			} else {
				printf("%5d %s %s\n", pe32.th32ProcessID,tim, pe32.szExeFile ); 
			}
		} while ( Process32Next( hProcessSnap, &pe32 ) );
	}
	CloseHandle(hProcessSnap);

	return 0;
}
